#if !defined(AFX_EXTPNEWPANBAR_H__00540515_F9CC_4900_B679_CE2FB7D9148A__INCLUDED_)
#define AFX_EXTPNEWPANBAR_H__00540515_F9CC_4900_B679_CE2FB7D9148A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ExtPNewPanBar.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CExtPNewPanBar window

//===========================================================================
// Summary:
//     The CExtPNewPanBar class derived from CDockablePane
//      F O P New Pan Bar
//===========================================================================

class CExtPNewPanBar : public CDockablePane
{
	// Construction
public:
	// constructor
	
	//-----------------------------------------------------------------------
	// Summary:
	// F O P New Pan Bar, Constructs a CExtPNewPanBar object.
	//		Returns A  value (Object).
	CExtPNewPanBar();

	// New style pan window
 
	// Pan, This member specify E-XD++ CFOPNewPanWnd object.  
	CFOPNewPanWnd m_wndPan;

	// Slider control
 
	// Slider, This member specify E-XD++ CFOZoomSliderCtrl object.  
	CFOZoomSliderCtrl   m_wndSlider;   

	// Obtain the pointer of the view.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Active View, Returns the specified value.
	//		Returns a pointer to the object CFOPCanvasCore ,or NULL if the call failed
	CFOPCanvasCore *GetActiveView();

	// Obtain the pointer of the valid active view.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Valid Active View, Returns the specified value.
	//		Returns a pointer to the object CFOPCanvasCore ,or NULL if the call failed
	CFOPCanvasCore *GetValidActiveView();

	// Change the pointer of the active view.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Active View, Sets a specify value to current class CExtPNewPanBar
	// Parameters:
	//		pView---pView, A pointer to the CFOPCanvasCore or NULL if the call failed.
	void SetActiveView(CFOPCanvasCore* pView);
	
	// Update current window.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Update Window, Call this member function to update the object.
	// Parameters:
	//		&bRedraw---&bRedraw, Specifies A Boolean value.
	void UpdateWnd(const BOOL &bRedraw = TRUE);

	void RedrawWindow();
	// Update zoom scale.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Update Zoom Scale, Call this member function to update the object.

	void UpdateZoomScale();

	// Convert scale value to pos.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Convert Sacle, .
	//		Returns a int type value.  
	// Parameters:
	//		&dScale---&dScale, Specifies a const double &dScale object(Value).
	int ConvertSacle(const double &dScale);

public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CExtPNewPanBar)
	//}}AFX_VIRTUAL

// Implementation
public:

	// destructor
	
	//-----------------------------------------------------------------------
	// Summary:
	// C F O P New Pan Bar, Destructor of class CExtPNewPanBar
	// This member function is also a virtual function, you can Override it if you need,  
	//		Returns A  value (Object).
	virtual ~CExtPNewPanBar();

 
	// Old Canvas, This member sets a CRect value.  
	CRect rcOldCanvas;
	// Generated message map functions
protected:

	//{{AFX_MSG(CExtPNewPanBar)
	
	//-----------------------------------------------------------------------
	// Summary:
	// On Create, Called as a part of window creation.
	//		Returns a int type value.  
	// Parameters:
	//		lpCreateStruct---Create Struct, Specifies a LPCREATESTRUCT lpCreateStruct object(Value).
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	
	//-----------------------------------------------------------------------
	// Summary:
	// On Size, Called after the size of CWnd has changed.
	// Parameters:
	//		nType---nType, Specifies A 16-bit unsigned integer on Windows versions 3.0 and 3.1; a 32-bit unsigned integer on Win32.  
	//		cx---Specifies A integer value.  
	//		cy---Specifies A integer value.
	afx_msg void OnSize(UINT nType, int cx, int cy);
	
	//-----------------------------------------------------------------------
	// Summary:
	// On Erase Background, Called when the window background needs erasing.
	//		Returns afx_msg BOOLvalue, TRUE on success; FALSE otherwise.  
	// Parameters:
	//		pDC---D C, A pointer to the CDC or NULL if the call failed.
	afx_msg BOOL OnEraseBkgnd( CDC* pDC );
	
	//-----------------------------------------------------------------------
	// Summary:
	// On V Scroll, Called when the user clicks the window's vertical scroll bar.
	// Parameters:
	//		nSBCode---S B Code, Specifies A 16-bit unsigned integer on Windows versions 3.0 and 3.1; a 32-bit unsigned integer on Win32.  
	//		nPos---nPos, Specifies A 16-bit unsigned integer on Windows versions 3.0 and 3.1; a 32-bit unsigned integer on Win32.  
	//		pScrollBar---Scroll Bar, A pointer to the CScrollBar or NULL if the call failed.
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//-----------------------------------------------------------------------
	// Summary:
	// On Timer, Called after each interval specified in SetTimer.
	// Parameters:
	//		nIDEvent---I D Event, Specifies A 16-bit unsigned integer on Windows versions 3.0 and 3.1; a 32-bit unsigned integer on Win32.
	afx_msg void OnTimer(UINT_PTR nIDEvent);

	//-----------------------------------------------------------------------
	// Summary:
	// On Paint, Called to repaint a portion of the window.

	afx_msg void OnPaint();
	//}}AFX_MSG
	
	//-----------------------------------------------------------------------
	// Summary:
	// E C L A R E_ M E S S A G E_ M A P, .
	//		Returns A  value (Object).
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EXTPNEWPANBAR_H__00540515_F9CC_4900_B679_CE2FB7D9148A__INCLUDED_)
