#if !defined(FO_MYBACKSHAPE_H__B82AE6E9_65EB_4ADC_920A_107D1B673F80__INCLUDED_)
#define FO_MYBACKSHAPE_H__B82AE6E9_65EB_4ADC_920A_107D1B673F80__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


//------------------------------------------------------
// Description
// Author: Author Name.
//------------------------------------------------------

/////////////////////////////////////////////////////////////////////////////////
//
// CMyBackShape -- background shape.
//

 
//===========================================================================
// Summary:
//     The CMyBackShape class derived from CFOBackShape
//      My Back Shape
//===========================================================================

class CMyBackShape : public CFOBackShape  
{
protected:
	
	//-----------------------------------------------------------------------
	// Summary:
	// E C L A R E_ S E R I A L, None Description.
	//		Returns A  value.  
	// Parameters:
	//		CMyBackShape---My Back Shape, Specifies a CMyBackShape object.
	DECLARE_SERIAL(CMyBackShape);

public:
	// Constructor
	
	//-----------------------------------------------------------------------
	// Summary:
	// My Back Shape, Constructs a CMyBackShape object.
	//		Returns A  value.  
	// Parameters:
	//		*pModel---*pModel, A pointer to the CFODataModel  or NULL if the call failed.
	CMyBackShape(CFODataModel *pModel = NULL);

	//-----------------------------------------------------------------------
	// Summary:
	// Copy constructor.
	
	//-----------------------------------------------------------------------
	// Summary:
	// My Back Shape, Constructs a CMyBackShape object.
	//		Returns A  value.  
	// Parameters:
	//		src---Specifies a const CMyBackShape& src object.
	CMyBackShape(const CMyBackShape& src);

	// Destructor.
	
	//-----------------------------------------------------------------------
	// Summary:
	// C My Back Shape, Destructor of class CMyBackShape
	// This member function is also a virtual function, you can Override it if you need,  
	//		Returns A  value.
	virtual ~CMyBackShape();

	// Assignment operator.
	
	//-----------------------------------------------------------------------
	// Summary:
	// None Description.
	//		Returns A CMyBackShape& value.  
	// Parameters:
	//		src---Specifies a const CMyBackShape& src object.
	CMyBackShape& operator=(const CMyBackShape& src);
	
	// Draw the form mode system button.
	// pDC -- pointer of CDC.
	// rect -- position of button.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Draw Form Dialog Button, Draws current object to the specify device.
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		*pDC---D C, A pointer to the CDC  or NULL if the call failed.  
	//		&rect---Specifies A CRect type value.
	virtual void DrawFormDialogButton(CDC *pDC,CRect &rect);

	//-----------------------------------------------------------------------
	// Summary:
	// Copy, Create a duplicate copy of this object.
	// This member function is also a virtual function, you can Override it if you need,  
	//		Returns a pointer to the object CFOBackShape,or NULL if the call failed
	// Creates a copy of this shape.
	virtual CFOBackShape* Copy() const;

	//-----------------------------------------------------------------------
	// Summary:
	// Load image from file.
	// strImagePath -- full path of image file.
	// crTransparent -- transparent color.
	// nImageType -- image type,it must be one of the following value:
	// enum FO_IMAGETYPE
	// {
	// 	FO_IMAGE_BMP = 0,
	// 	FO_IMAGE_ICO,
	// 	FO_IMAGE_PCX,
	// 	FO_IMAGE_JPG,
	// 	FO_IMAGE_PNG,
	// 	FO_IMAGE_GIF,
	// 	FO_IMAGE_TGA
	// };
	
	//-----------------------------------------------------------------------
	// Summary:
	// Load Image, Call this function to read a specified number of bytes from the archive.
	//		Returns TRUE on success; FALSE otherwise.  
	// Parameters:
	//		strImagePath---Image Path, Specifies A CString type value.  
	//		&nImageType---Image Type, Specifies a const FO_IMAGETYPE &nImageType = FO_IMAGE_BMP object.  
	//		crTransparent---crTransparent, Specifies A 32-bit value used as a color value.  
	//		255---Specifies a 255 object.  
	//		255)---Specifies a 255) object.
	BOOL LoadImage(CString strImagePath,const FO_IMAGETYPE &nImageType = FO_IMAGE_BMP,COLORREF crTransparent = RGB(255,255,255));
	
	//-----------------------------------------------------------------------
	// Summary:
	// Load image from resource id.
	// nID -- image resource id.
	// crTransparent -- transparent color.
	// nImageType -- image type,it must be one of the following value:
	// enum FO_IMAGETYPE
	// {
	// 	FO_IMAGE_BMP = 0,
	// 	FO_IMAGE_ICO,
	// 	FO_IMAGE_PCX,
	// 	FO_IMAGE_JPG,
	// 	FO_IMAGE_PNG,
	// 	FO_IMAGE_GIF,
	// 	FO_IMAGE_TGA
	// };
	// pcszResourceType -- Resource type name.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Load Image, Call this function to read a specified number of bytes from the archive.
	//		Returns TRUE on success; FALSE otherwise.  
	// Parameters:
	//		nID---I D, Specifies A 16-bit unsigned integer on Windows versions 3.0 and 3.1; a 32-bit unsigned integer on Win32.  
	//		pcszResourceType---Resource Type, Specifies A 32-bit pointer to a constant character string that is portable for Unicode and DBCS.  
	//		&nImageType---Image Type, Specifies a const FO_IMAGETYPE &nImageType = FO_IMAGE_BMP object.  
	//		crTransparent---crTransparent, Specifies A 32-bit value used as a color value.  
	//		255---Specifies a 255 object.  
	//		255)---Specifies a 255) object.
	BOOL LoadImage(UINT nID,LPCTSTR pcszResourceType,const FO_IMAGETYPE &nImageType = FO_IMAGE_BMP,COLORREF crTransparent = RGB(255,255,255));

	// call this method to put the text object into edit in place mode
	
	//-----------------------------------------------------------------------
	// Summary:
	// Do Start Show Edit, Do a event. 
	// This member function is also a virtual function, you can Override it if you need,  
	//		Returns TRUE on success; FALSE otherwise.
	virtual BOOL DoImageLoading();

	// Cancel image.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Cancel Image, None Description.

	void CancelImage();

	//
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set New Image, Sets a specify value to current class CMyBackShape
	//		Returns a CString type value.  
	// Parameters:
	//		&strImage---&strImage, Specifies A CString type value.
	CString SetNewImage(const CString &strImage);
    
public:
	// Draw margin of the form.
	
	//-----------------------------------------------------------------------
	// Summary:
	// On Draw Page Margin, This member function is called by the framework to allow your application to handle a Windows message.
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		*pDC---D C, A pointer to the CDC  or NULL if the call failed.  
	//		&rect---Specifies A CRect type value.  
	//		&rcClip---&rcClip, Specifies A CRect type value.
	virtual void OnDrawPageMargin(CDC *pDC,CRect &rect,const CRect &rcClip);

	// Draw the background of the form.
	
	//-----------------------------------------------------------------------
	// Summary:
	// On Draw Back, Draw the background of this canvas.
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		*pDC---D C, A pointer to the CDC  or NULL if the call failed.  
	//		&rcClip---&rcClip, Specifies A CRect type value.
	virtual void OnDrawBack(CDC *pDC,const CRect &rcClip);

	// Draw the grid.
	
	//-----------------------------------------------------------------------
	// Summary:
	// On Draw Grid, This member function is called by the framework to allow your application to handle a Windows message.
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		*pDC---D C, A pointer to the CDC  or NULL if the call failed.  
	//		&rect---Specifies A CRect type value.  
	//		&rcClip---&rcClip, Specifies A CRect type value.
	virtual void OnDrawGrid(CDC *pDC,CRect &rect,const CRect &rcClip);

	// Draw mark of the form.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Draw Form Drag Mark, Draws current object to the specify device.
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		*pDC---D C, A pointer to the CDC  or NULL if the call failed.  
	//		&rect---Specifies A CRect type value.
	virtual void DrawFormDragMark(CDC *pDC,CRect &rect);

	// Draw form body.
	// pDC -- pointer of the DC.
	// rcClip -- Clip rectangle for drawing.
	
	//-----------------------------------------------------------------------
	// Summary:
	// On Draw Form, This member function is called by the framework to allow your application to handle a Windows message.
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		*pDC---D C, A pointer to the CDC  or NULL if the call failed.  
	//		&rcClip---&rcClip, Specifies A CRect type value.
	virtual void OnDrawForm(CDC *pDC,const CRect &rcClip);

public:
	
	// Get image data.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Image Data, Returns the specified value.
	//		Returns a pointer to the object CFOBitmap ,or NULL if the call failed
	CFOBitmap *GetImageData() const	{ return m_pImagePtr->GetBitmap(); }
	
	// Image ptr.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Pointer, Returns the specified value.
	//		Returns a pointer to the object CFODrawImage,or NULL if the call failed
	CFODrawImage* GetPtr()				{ return m_pImagePtr; }

	// Init image position.
	// nImageWidth -- image width.
	// nImageHeight -- image height.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Do Initial Image Position, Do a event. 
	// This member function is also a virtual function, you can Override it if you need,  
	//		Returns a CRect type value.  
	// Parameters:
	//		nImageWidth---Image Width, Specifies A integer value.  
	//		nImageHeight---Image Height, Specifies A integer value.
	virtual CRect DoInitImagePos(int nImageWidth,int nImageHeight);

	// Draw image in a box.
	// pDC -- pointer of the DC.
	// rcPos -- position of the image.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Do Draw Image, Do a event. 
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		*pDC---D C, A pointer to the CDC  or NULL if the call failed.  
	//		rcPos---rcPos, Specifies A CRect type value.
	virtual void DoDrawImage(CDC *pDC,CRect rcPos);
	
	// Is transparent.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Is Image Transparent, Determines if the given value is correct or exist.
	//		Returns TRUE on success; FALSE otherwise.
	BOOL IsImageTransparent() const { return m_bImageTransparent; }
	
	// Set transparent.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Image Transparent, Sets a specify value to current class CMyBackShape
	// Parameters:
	//		bTrans---bTrans, Specifies A Boolean value.
	void SetImageTransparent(const BOOL bTrans);
	
	// Get transparent color.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Image Transparent Color, Returns the specified value.
	//		Returns A 32-bit value used as a color value.
	COLORREF GetImageTransparentColor() const { return m_crImageTransparent; }
	
	// Set transparent color.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Image Transparent Color, Sets a specify value to current class CMyBackShape
	// Parameters:
	//		crTrans---crTrans, Specifies A 32-bit value used as a color value.
	void SetImageTransparentColor(const COLORREF crTrans);
	// Restore to default size of image.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Restore Default Size, None Description.
	//		Returns TRUE on success; FALSE otherwise.
	BOOL RestoreDefaultSize();
	
	// 
	
	//-----------------------------------------------------------------------
	// Summary:
	// Correct Image Rectangle, None Description.
	//		Returns A FOPRect value.  
	// Parameters:
	//		&rcOld---&rcOld, Specifies a const FOPRect &rcOld object.  
	//		nImageWidth---Image Width, Specifies A integer value.  
	//		nImageHeight---Image Height, Specifies A integer value.
	FOPRect CorrectImageRect(const FOPRect &rcOld, int nImageWidth, int nImageHeight);

	// Is validate.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Is Validate, Determines if the given value is correct or exist.
	//		Returns TRUE on success; FALSE otherwise.
	BOOL	IsValidate();

	
	//-----------------------------------------------------------------------
	// Summary:
	// Serialize, Reads or writes this object from or to an archive.
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		&ar---Specifies a CArchive &ar object.
	// Serializes the data.
	virtual void Serialize(CArchive &ar);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Offset Image, None Description.
	// Parameters:
	//		ptNew---ptNew, Specifies A CPoint type value.
	void OffsetImage(CPoint ptNew);

 
	// Image Color Property, This member specify E-XD++ CFOImageExtProp object.  
	CFOImageExtProp m_ImageColorProp;
protected:
	
	// Image data.
 
	// Image Data, This member specify E-XD++ CFOImageData object.  
	static CFOImageData m_ImageData;
	
public:
	
	// Image data.
 
	// Image Pointer, This member specify E-XD++ CFODrawImageData object.  
	CFODrawImageData	m_pImagePtr;
	
	// Image data.
 
	// Image Rotate Pointer, This member maintains a pointer to the object CFODrawImage.  
	CFODrawImage*	   m_pImageRotatePtr;
	
	// Is transparent or not.
 
	// Image Transparent, This member sets TRUE if it is right.  
	BOOL				m_bImageTransparent;
	
	// Transparent color.
 
	// Image Transparent, This member sets A 32-bit value used as a color value.  
	COLORREF			m_crImageTransparent;
	
	// And mask image object.
 
	// Image Pointer And Mask, This member maintains a pointer to the object CFOBitmap.  
	CFOBitmap *			m_pImagePtrAndMask;
	
	// Or mask image object.
 
	// Image Pointer Or Mask, This member maintains a pointer to the object CFOBitmap.  
	CFOBitmap *			m_pImagePtrOrMask;
	
	// Image file type.
 
	// Image Type, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int					m_nImageType;
	
	// Current timer ID
 
	// Timer I D, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int					m_nTimerID;
	
	// Current frame
 
	// m_nFrame, This member can be sets with A 16-bit unsigned integer on Windows versions 3.0 and 3.1; a 32-bit unsigned integer on Win32.  
	UINT				m_nFrame;
	
	// Is gif or not.
 
	// m_bGif, This member sets TRUE if it is right.  
	BOOL				m_bGif;
	
	// Drawing image.
 
	// Draw Image, This member specify FOImageObj object.  
	FOImageObj			m_DrawImage;

	// Image start point
 
	// Image Start, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	FOPPoint			m_ptImageStart;
	
	// position
 
	// m_rectPosition, This member specify FOPRect object.  
	FOPRect				m_rectPosition;

	
	// Image file name.
 
	// Image File, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString				m_strImageFile;
	
	// Center image.
 
	// Center Image, This member sets TRUE if it is right.  
	BOOL				m_bCenterImage;
public:

#ifdef _DEBUG
	
	//-----------------------------------------------------------------------
	// Summary:
	// Assert Valid, Assert performs a validity check on this object by checking its internal state.
	// This member function is also a virtual function, you can Override it if you need,
	virtual void AssertValid() const;
	
	//-----------------------------------------------------------------------
	// Summary:
	// Dump, Dumps the contents of your object to a CDumpContext object.
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		dc---Specifies a CDumpContext& dc object.
	virtual void Dump(CDumpContext& dc) const;
#endif

};
 
#endif // !defined(FO_MYBACKSHAPE_H__B82AE6E9_65EB_4ADC_920A_107D1B673F80__INCLUDED_)
